/*!	\file config.h
\brief grundsaetzliche Konfiguration

Wird normalerweise im Makefile gemacht. Ich mache das hier, sodass bei einer
Aenderung automatisch das gesamte Projekt neu gebaut wird (kein make clean"
notwendig).

\author Michael Kramer <michakramer@t-online.de>
\author					2:240/1120.13
\date 2015
*/

#ifndef CONFIG_H
#define CONFIG_H

#include <stdint.h>

#define F_CPU 8000000UL	/**< CPU-Takt in Herz							*/

#define DEBUG				/**< wenn definiert, wird Debug-Code erzeugt	*/

/*! \name allgemeine Macros
*/
/*@{*/
typedef int8_t boolean;
#define FALSE 0
#define TRUE (!FALSE)

#define RET_FAILURE		0	/**< Funktionsende mit Fehler					*/
#define RET_SUCCESS		1	/**< Funktionsende erfolgreich					*/
/*@}*/

/*! \name Standarderweiternde Macros
	Macros zur Zahlenverarbeitung.	*/
/*@{*/
#define EVEN(a)		!((a) % 2)						/**< gibt 1 zurueck wenn a grade ist		*/
#define ABS(a)	   (((a) < 0) ? -(a) : (a)) 		/**< gibt Absolutwert zurueck				*/
#define uniq(LOW,HEIGHT)	((HEIGHT << 8)|LOW)		/**< erzeugt eine 16Bit Zahl aus 2 Byte		*/
#define LOW_BYTE(x)        	(x & 0xff)				/**< gibt das low Byte einer 16Bit Zahl		*/
#define HIGH_BYTE(x)       	((x >> 8) & 0xff)		/**< gibt das high Byte einer 16Bit Zahl	*/

/*@}*/

#endif /* CONFIG_H */
