#include "config.h"
#include <avr/io.h>
#include "adc.h"

uint16_t adc_read(uint8_t mux)
{
	uint16_t i;
	uint32_t result = 0;

	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (0<<ADPS1) | (1<<ADPS0);	// Frequenzvorteiler

	ADMUX = mux & 0x0f;					// Kanal waehlen
	ADMUX &= ~((1<<REFS0) | (1<<REFS1)); // VCC(5V) als Referenzspannung nutzen

/*	nach Aktivieren des ADC wird ein "Dummy-Readout" empfohlen, man liest
	also einen Wert und verwirft diesen, um den ADC "warmlaufen zu lassen" */
	ADCSRA |= (1<<ADSC);			// eine ADC-Wandlung
	while ( ADCSRA & (1<<ADSC) ) {
		;     						// auf Abschluss der Konvertierung warten
	}

/* Eigentliche Messung - Mittelwert aus 256 aufeinanderfolgenden Wandlungen */
	for(i = 0; i < 256; i++)
	{
		ADCSRA |= (1<<ADSC);		// eine Wandlung "single conversion"
		while ( ADCSRA & (1<<ADSC) ) {
			;						// auf Abschluss der Konvertierung warten
		}
		result += ADCW;				// Wandlungsergebnisse aufaddieren
	}
	ADCSRA &= ~(1<<ADEN);			// ADC deaktivieren (2)

	return result >> 4; 			//Ergebins durch 16 teilen
}
