#include "config.h"
#include <avr/io.h>
//#include <avr/signal.h>
#include <avr/interrupt.h>
#include "watchdog.h"

volatile uint8_t	wd_flag = FALSE;	/**< Flag zum erkennen Aufwecken durch Watchdog	*/

SIGNAL(SIG_WATCHDOG_TIMEOUT)
{
	WDTCR &= ~(1<<WDIE);			// Disable Watchdog Interrupt Mode
									// This can be omitted if repeated interrups are needed
	wd_flag = TRUE;
}

/* Initialization routine */
void WDT_Initialization_as_Wakeup_Source( void )
{
/* Setup Watchdog */
// Use Timed Sequence for disabling Watchdog System Reset Mode if it has been enabled unintentionally.
	MCUSR  &=  ~(1 << WDRF);							// Clear WDRF if it has been unintentionally set.
	WDTCR   =   (1 << WDCE ) | (1 << WDE);				// Enable configuration change.
	WDTCR   =   (1 << WDIF) | (1 << WDIE) |				// Enable Watchdog Interrupt Mode.
				(1 << WDCE) | (0 << WDE) |				// Disable Watchdog System Reset Mode if unintentionally enabled.
//				(0 << WDP3) | (1 << WDP2) | (1 << WDP1) | (0 << WDP0);// Set Watchdog Timeout period to 1.0 sec.
				(1 << WDP3) | (0 << WDP2) | (0 << WDP1) | (1 << WDP0);// Set Watchdog Timeout period to 8.0 sec.

	wd_flag = FALSE;
}

/** Funktion gibt Zustand des Watchdog-Flags zurueck und setzt ihn auf FALSE
\return Zustand Watchdog-Flag beim Aufruf
*/
uint8_t watchdog_flag(void)
{
	uint8_t flag = wd_flag;

	wd_flag = FALSE;
	return flag;
}

